<template>
  <div>
    <!-- MOTIVATION IMAGE -->
    <template v-if="habitLocal.motivationImages.length > 0">
      <!-- Image Container -->
      <div class="img-container w-64 mx-auto flex items-center justify-center">
        <img
          :src="habitLocal.motivationImages[0]"
          alt="img"
          class="responsive"
        />
      </div>

      <!-- Image Upload Buttons -->
      <div class="modify-img flex justify-between mt-5">
        <input
          type="file"
          class="hidden"
          ref="updateImgInput"
          @change="updateCurrImg"
          accept="image/*"
        />
        <vs-button
          class="mr-4"
          type="flat"
          @click="$refs.updateImgInput.click()"
          >Chỉnh sửa ảnh</vs-button
        >
        <vs-button
          type="flat"
          color="#999"
          @click="updateData('motivationImages', [])"
          >Xóa ảnh</vs-button
        >
      </div>
    </template>

    <!-- Add Cover Image Btn -->
    <div class="mt-5 w-full ttd-img-upload">
      <p class="text-center font-semibold mb-5">Ảnh tạo động lực</p>
      <div
        class="ttd-input-upload"
        v-if="habitLocal.motivationImages.length == 0"
        @click="$refs.uploadImgInput.click()"
      >
        <input
          type="file"
          class="hidden"
          ref="uploadImgInput"
          @change="updateCurrImg"
          accept="image/*"
        />
        <span class="text-input">Tải lên ảnh</span>
      </div>
    </div>
    <!-- /MOTIVATION IMAGE -->

    <!-- Name Field -->
    <div class="mt-5 w-full">
      <h6 class="mb-2">Tên</h6>
      <vs-input
        v-model="habitLocal.name"
        class="mt-5 w-full"
        name="item-name"
        v-validate="'required'"
        @change="updateData('name', $event.target.value)"
      />
      <span class="text-danger text-sm" v-show="errors.has('item-name')">{{
        errors.first("item-name")
      }}</span>
    </div>

    <!-- Category Field: TODO STH... -->
    <!-- <div class="mt-5 w-full">
          <h6 class="mb-2">Thể loại</h6>
          <v-select
            v-model="dataCategory"
            :options="category_choices"
            :dir="$vs.rtl ? 'rtl' : 'ltr'"
          />
          <br />
        </div>
        <span
          class="text-danger text-sm"
          v-show="errors.has('item-category')"
          >{{ errors.first("item-category") }}</span
        > -->

    <!-- Select Icon -->
    <div class="w-full mt-5">
      <HabitIconSelect
        :iconColor="habitLocal.iconColor"
        :iconText="habitLocal.iconText"
        :iconImage="habitLocal.iconImage"
        @change="updateData($event.field, $event.text)"
      />
    </div>

    <div class="mt-5 w-full">
      <HabitQuoteSelect
        v-model="habitLocal.motivationContent"
        @input="updateData('motivationContent', $event)"
      />
    </div>
  </div>
</template>

<script>
import HabitIconSelect from "./HabitIconSelect";
import HabitQuoteSelect from "./HabitQuoteSelect";

export default {
  components: {
    HabitIconSelect,
    HabitQuoteSelect
  },
  props: {
    value: { type: Object, default: () => ({}) }
  },
  data() {
    return {
      habitLocal: this.value
    };
  },
  watch: {
    value(val) {
      // console.log("[GENERAL] habitLocal =", val);
      this.habitLocal = val;
    }
  },
  methods: {
    updateData(field, text) {
      // console.log("[HABIT_FORM]", field, text);
      const newData = { ...this.value, [field]: text };
      this.$emit("input", newData);
    },
    updateCurrImg(input) {
      if (input.target.files && input.target.files[0]) {
        var reader = new FileReader();
        reader.onload = e => {
          this.updateData("motivationImages", [e.target.result]);
        };
        reader.readAsDataURL(input.target.files[0]);
      }
    }
  }
};
</script>

<style lang="scss" scoped>
@import "@/assets/scss/vuexy/_variables.scss";

[dir] .border-primary {
  border-color: rgba(234, 232, 253, 1) !important;
}
[dir] .border-secondary {
  border-color: rgba(238, 238, 238, 1) !important;
}

.ttd-img-upload {
  padding: 0.6rem;

  .ttd-input-upload {
    margin: 0;
    height: 2.5rem;
    width: 100%;
    border: 1px dashed rgba(0, 0, 0, 0.1);
    background: #f5f5f5;
    border-radius: 8px;
    transition: all 0.25s ease;
    align-items: center;
    justify-content: center;
    cursor: pointer;

    display: -webkit-box;

    .text-input {
      min-width: 200px;
      display: block;
      text-align: center;
      margin: 0 !important;
      padding: 0 !important;
      width: 100%;
      font-weight: 700;
    }

    &:hover {
      border: 1px dashed $primary !important;
      box-shadow: 0px 0px 0px 0px rgba(0, 0, 0, 0.05);
      transform: translate(0, 4px);
    }
  }
}
</style>

<style lang="scss">
#motivation-img-upload {
  .view-upload {
    z-index: 40000;
  }

  .con-img-upload {
    .con-input-upload,
    .img-upload {
      width: 100px;
      height: 100px;
      margin: 9px;
    }
  }
}
</style>
